function [subbands subband_envs audio_filts] = erbcochleagram(clip,sr)

sample_sound = clip;

P.desired_rms = .01; %.1 was too high; some files clipped during wavwrite; .01 prevents clipping but is a little low for laptop speakers
P.audio_sr = sr;
P.N_audio_channels = 62; %this is the number excluding lowpass and highpass filters on ends of spectrum
P.low_audio_f = 20; %Hz
P.hi_audio_f = 14000; %Hz
P.use_more_audio_filters = 0; % should be 1 if 2x overcomplete, 2 if 4x overcomplete
P.lin_or_log_filters = 1; %1--> log acoustic & mod; 2--> log acoust, lin mod; 3--> lin acoust, log mod; 4--> lin acoust, lin mod
P.env_sr = 50;
P.compression_option=1; % should be 0 for no compression, 1 for power compression, 2 for logarithmic compression
P.comp_exponent = .3;
P.log_constant = 10^-12; %this is the constant added prior to taking the log


  if P.lin_or_log_filters==1 || P.lin_or_log_filters==2
        if P.use_more_audio_filters==0
            [audio_filts, audio_cutoffs_Hz] = make_erb_cos_filters(length(sample_sound), P.audio_sr, P.N_audio_channels, P.low_audio_f, P.hi_audio_f);
        elseif P.use_more_audio_filters==1
            [audio_filts, audio_cutoffs_Hz] = make_erb_cos_filts_double2(length(sample_sound), P.audio_sr, P.N_audio_channels, P.low_audio_f, P.hi_audio_f);
        elseif P.use_more_audio_filters==2
            [audio_filts, audio_cutoffs_Hz] = make_erb_cos_filts_quadruple2(length(sample_sound), P.audio_sr, P.N_audio_channels, P.low_audio_f, P.hi_audio_f);
        end
    elseif P.lin_or_log_filters==3 || P.lin_or_log_filters==4
        if P.use_more_audio_filters==0
            [audio_filts, audio_cutoffs_Hz] = make_lin_cos_filters(length(sample_sound), P.audio_sr, P.N_audio_channels, P.low_audio_f, P.hi_audio_f);
        elseif P.use_more_audio_filters==1
            [audio_filts, audio_cutoffs_Hz] = make_lin_cos_filts_double(length(sample_sound), P.audio_sr, P.N_audio_channels, P.low_audio_f, P.hi_audio_f);
        end
  end
    
  
%generate subbands and subband envelopes from which statistics are measured
subbands = generate_subbands(sample_sound, audio_filts);
%analytic_subbands = hilbert(subbands);
subband_envs = abs(hilbert(subbands));
if P.compression_option==1 %power compression
    subband_envs = subband_envs.^P.comp_exponent;
elseif P.compression_option==2 %log compression
    subband_envs = log10(subband_envs+P.log_constant);
end

ds_factor=P.audio_sr/P.env_sr;
subband_envs = resample(subband_envs,1,ds_factor);
subband_envs(subband_envs<0)=0;

end
